//+------------------------------------------------------------------+
//|                                                   .mq4 |
//|                                                                 |
//|                                                    |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "  "

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

#define Pi 3.14159265358979323846

//--- input parameters
extern int N=10;// 
extern int k=1;//  
extern int Win=300;//  
extern bool Phase=false;
extern bool z;

double i[];// 

//  
double I[];// 
double Q[];//

double a,b,c;//

//--- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int fo;

int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   
   ArrayResize(i,Win+N-1);
   ArrayResize(I,Win+N-1);
   ArrayResize(Q,Win+N-1);
   
   //
   a=MathCos(2*Pi*k/N);
   b=MathSin(2*Pi*k/N);
   
   fo=FileOpen("Spectr.csv",FILE_CSV|FILE_WRITE,';');
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
   
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   ArrayInitialize(ExtMapBuffer1,EMPTY_VALUE);
   ArrayCopy(i,Close,0,0,Win+N-1);
   //for(int j=0;j<Win+N-1;j++)
      //i[j]=Close[j]-Close[j+1];
   
   for(int n=Win+N-2;n>=0;n--)//   
     {c=I[n+1]+i[n]-i[n+N];
      I[n]=a*c-b*Q[n+1];// 
      Q[n]=a*Q[n+1]+b*c;//
     }
   for(n=Win-1;n>=0;n--)
      if(!Phase)
         ExtMapBuffer1[n]=MathSqrt(I[n]*I[n]+Q[n]*Q[n]);//
      else
         ExtMapBuffer1[n]=MathArctan(Q[n]/I[n])*180/Pi;//
   //Alert(I[7]," ",Q[7]);
   if(z)
     {z=0;
      for(n=Win-1;n>=0;n--)
        {FileWrite(fo,ExtMapBuffer1[n]);}//FileSeek(fo,-2,SEEK_CUR);}
      //FileSeek(fo,2,SEEK_CUR);
      FileClose(fo);
      Alert(".  Spectr");
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+